# For each

A special block that iterates over each element in an array, entry in a dictionary, character in a text, or a number of times.

The fiber will proceed immediately without pause.

The path connected to the DO connector dot are followed for every element in a array, entry in a dictionary or the number of times specified in the container. When the iteration is complete, the OK path are followed, as usual. The path and subsequent blocks, connected to the DO dot must end at the IN dot on the same For each block, to complete the iteration loop.

This block iterates a shallow copy of the container so modifying the container during the iteration is possible without interference.

## Input arguments

- Container — array, dictionary, text to be iterated, or the number of times to iterate.

## Output variables

- Entry value — variable to assign the element/entry/character value.
- Entry index — variable to assign the current iteration count.
- Dictionary key — variable to assign the dictionary entry key.

## Conditions

- Until — iteration will continue until this expression evaluate to true, may include above output variables.